Index: branches/HTM-DEV-0.1-dev/source/Lib/TLibCommon/CommonDef.h
===================================================================
--- branches/HTM-DEV-0.1-dev/source/Lib/TLibCommon/CommonDef.h	(revision 367)
+++ branches/HTM-DEV-0.1-dev/source/Lib/TLibCommon/CommonDef.h	(revision 368)
@@ -56,5 +56,10 @@
 // ====================================================================================================================
 
+#if H_MV
+#define NV_VERSION        "0.1"                 ///< Current software version
+#define HM_VERSION        "10.1"                ///< 
+#else
 #define NV_VERSION        "10.1"                 ///< Current software version
+#endif
 
 // ====================================================================================================================
@@ -152,4 +157,15 @@
 }
 
+#if H_MV
+
+#define AOF( exp )                  \
+{                                   \
+  if( !( exp ) )                    \
+{                                 \
+  assert( 0 );                    \
+}                                 \
+}
+
+#endif
 
 // ====================================================================================================================
Index: branches/HTM-DEV-0.1-dev/source/Lib/TLibCommon/NAL.h
===================================================================
--- branches/HTM-DEV-0.1-dev/source/Lib/TLibCommon/NAL.h	(revision 367)
+++ branches/HTM-DEV-0.1-dev/source/Lib/TLibCommon/NAL.h	(revision 368)
@@ -47,5 +47,9 @@
   NalUnitType m_nalUnitType; ///< nal_unit_type
   UInt        m_temporalId;  ///< temporal_id
+#if H_MV
+  Int         m_layerId;     ///< layer id
+#else
   UInt        m_reservedZero6Bits; ///< reserved_zero_6bits
+#endif
 
   /** construct an NALunit structure with given header values. */
@@ -53,8 +57,16 @@
     NalUnitType nalUnitType,
     Int         temporalId = 0,
+#if H_MV
+    Int         layerId = 0)
+#else
     Int         reservedZero6Bits = 0)
+#endif
     :m_nalUnitType (nalUnitType)
     ,m_temporalId  (temporalId)
+#if H_MV
+    ,m_layerId     (layerId)
+#else
     ,m_reservedZero6Bits(reservedZero6Bits)
+#endif
   {}
 
Index: branches/HTM-DEV-0.1-dev/source/Lib/TLibCommon/TComPic.cpp
===================================================================
--- branches/HTM-DEV-0.1-dev/source/Lib/TLibCommon/TComPic.cpp	(revision 367)
+++ branches/HTM-DEV-0.1-dev/source/Lib/TLibCommon/TComPic.cpp	(revision 368)
@@ -64,4 +64,11 @@
 , m_pNDBFilterYuvTmp                      (NULL)
 , m_bCheckLTMSB                           (false)
+#if H_MV
+, m_layerId                               (0)
+, m_viewId                                (0)
+#if H_3D
+, m_isDepth                               (false)
+#endif
+#endif
 {
   m_apcPicYuv[0]      = NULL;
@@ -464,4 +471,13 @@
 
 }
+#if H_MV
+Void TComPic::print( Bool legend )
+{
+  if ( legend )
+    std::cout  << "LId"        << "\t" << "POC"   << "\t" << "Rec"          << "\t" << "Ref"                       << "\t" << "LT"            << std::endl;
+  else
+    std::cout  << getLayerId() << "\t" << getPOC()<< "\t" << getReconMark() << "\t" << getSlice(0)->isReferenced() << "\t" << getIsLongTerm() << std::endl;
+}
+#endif
 
 
Index: branches/HTM-DEV-0.1-dev/source/Lib/TLibCommon/TComPic.h
===================================================================
--- branches/HTM-DEV-0.1-dev/source/Lib/TLibCommon/TComPic.h	(revision 367)
+++ branches/HTM-DEV-0.1-dev/source/Lib/TLibCommon/TComPic.h	(revision 368)
@@ -86,4 +86,11 @@
   SEIMessages  m_SEIs; ///< Any SEI messages that have been received.  If !NULL we own the object.
 
+#if H_MV
+  Int                   m_layerId;
+  Int                   m_viewId;
+#if H_3D
+  Bool                  m_isDepth;
+#endif
+#endif
 public:
   TComPic();
@@ -98,4 +105,14 @@
   Void          setTLayer( UInt uiTLayer ) { m_uiTLayer = uiTLayer; }
 
+#if H_MV
+  Void          setLayerId            ( Int layerId )    { m_layerId      = layerId; }
+  Int           getLayerId            ()                 { return m_layerId;    }
+  Void          setViewId             ( Int viewId )     { m_viewId = viewId;   }
+  Int           getViewId             ()                 { return m_viewId;     }
+#if H_3D
+  Void          setIsDepth            ( Bool isDepth )   { m_isDepth = isDepth; }
+  Bool          getIsDepth            ()                 { return m_isDepth; }
+#endif
+#endif
   Bool          getUsedByCurr()             { return m_bUsedByCurr; }
   Void          setUsedByCurr( Bool bUsed ) { m_bUsedByCurr = bUsed; }
@@ -164,4 +181,7 @@
   std::vector<TComDataCU*>& getOneSliceCUDataForNDBFilter      (Int sliceID) { return m_vSliceCUDataLink[sliceID];}
 
+#if H_MV
+  Void          print( Bool legend );
+#endif
   /** transfer ownership of seis to this picture */
   void setSEIs(SEIMessages& seis) { m_SEIs = seis; }
@@ -179,4 +199,51 @@
 };// END CLASS DEFINITION TComPic
 
+#if H_MV
+class TComPicLists 
+{
+private: 
+  TComList<TComList<TComPic*>*> m_lists; 
+public: 
+  
+  Void push_back( TComList<TComPic*>* list ) { m_lists.push_back( list ); }
+  Int  size     ()                           { return (Int) m_lists.size    (); } 
+
+  TComPic* getPic( Int layerIdInNuh, Int poc )
+  { 
+    TComPic* pcPic = NULL;
+    for(TComList<TComList<TComPic*>*>::iterator itL = m_lists.begin(); ( itL != m_lists.end() && pcPic == NULL ); itL++)
+    {    
+      for(TComList<TComPic*>::iterator itP=(*itL)->begin(); ( itP!=(*itL)->end() && pcPic == NULL ); itP++)
+      {
+        if ( ( (*itP)->getPOC() == poc ) && ( (*itP)->getLayerId() == layerIdInNuh ) )
+        {
+          pcPic = *itP ;      
+        }
+      }
+    }
+    return pcPic;
+  }
+
+  Void print( )
+  { 
+    Bool first = true;     
+    for(TComList<TComList<TComPic*>*>::iterator itL = m_lists.begin(); ( itL != m_lists.end() ); itL++)
+    {    
+      for(TComList<TComPic*>::iterator itP=(*itL)->begin(); ( itP!=(*itL)->end() ); itP++)
+      {
+        if ( first )
+        {
+          (*itP)->print( true );       
+          first = false; 
+        }
+        (*itP)->print( false );       
+      }
+    }
+  }
+
+
+}; // END CLASS DEFINITION TComPicLists
+
+#endif 
 //! \}
 
Index: branches/HTM-DEV-0.1-dev/source/Lib/TLibCommon/TComSlice.cpp
===================================================================
--- branches/HTM-DEV-0.1-dev/source/Lib/TLibCommon/TComSlice.cpp	(revision 367)
+++ branches/HTM-DEV-0.1-dev/source/Lib/TLibCommon/TComSlice.cpp	(revision 368)
@@ -107,4 +107,11 @@
 , m_temporalLayerNonReferenceFlag ( false )
 , m_enableTMVPFlag                ( true )
+#if H_MV
+, m_layerId                       (0)
+, m_viewId                        (0)
+#if H_3D
+, m_isDepth                       (false)
+#endif
+#endif
 {
 #if L0034_COMBINED_LIST_CLEANUP
@@ -138,4 +145,8 @@
     m_aiRefPOCList  [0][iNumCount] = 0;
     m_aiRefPOCList  [1][iNumCount] = 0;
+#if H_MV
+    m_aiRefLayerIdList[0][iNumCount] = 0;
+    m_aiRefLayerIdList[1][iNumCount] = 0;
+#endif
   }
   resetWpScaling();
@@ -309,4 +320,7 @@
     {
       m_aiRefPOCList[iDir][iNumRefIdx] = m_apcRefPicList[iDir][iNumRefIdx]->getPOC();
+#if H_MV
+      m_aiRefLayerIdList[iDir][iNumRefIdx] = m_apcRefPicList[iDir][iNumRefIdx]->getLayerId();
+#endif
     }
   }
@@ -354,5 +368,10 @@
         for ( Int iRefIdxLC = 0; iRefIdxLC < m_aiNumRefIdx[REF_PIC_LIST_C]; iRefIdxLC++ )
         {
+#if H_MV
+          if ( m_apcRefPicList[REF_PIC_LIST_0][iNumRefIdx]->getPOC() == m_apcRefPicList[m_eListIdFromIdxOfLC[iRefIdxLC]][m_iRefIdxFromIdxOfLC[iRefIdxLC]]->getPOC() &&
+               m_apcRefPicList[REF_PIC_LIST_0][iNumRefIdx]->getLayerId() == m_apcRefPicList[m_eListIdFromIdxOfLC[iRefIdxLC]][m_iRefIdxFromIdxOfLC[iRefIdxLC]]->getLayerId() )
+#else
           if ( m_apcRefPicList[REF_PIC_LIST_0][iNumRefIdx]->getPOC() == m_apcRefPicList[m_eListIdFromIdxOfLC[iRefIdxLC]][m_iRefIdxFromIdxOfLC[iRefIdxLC]]->getPOC() )
+#endif 
           {
             m_iRefIdxOfL1FromRefIdxOfL0[iNumRefIdx] = m_iRefIdxFromIdxOfLC[iRefIdxLC];
@@ -376,5 +395,10 @@
         for ( Int iRefIdxLC = 0; iRefIdxLC < m_aiNumRefIdx[REF_PIC_LIST_C]; iRefIdxLC++ )
         {
+#if H_MV
+          if ( m_apcRefPicList[REF_PIC_LIST_1][iNumRefIdx]->getPOC() == m_apcRefPicList[m_eListIdFromIdxOfLC[iRefIdxLC]][m_iRefIdxFromIdxOfLC[iRefIdxLC]]->getPOC() &&
+               m_apcRefPicList[REF_PIC_LIST_1][iNumRefIdx]->getLayerId() == m_apcRefPicList[m_eListIdFromIdxOfLC[iRefIdxLC]][m_iRefIdxFromIdxOfLC[iRefIdxLC]]->getLayerId() )
+#else
           if ( m_apcRefPicList[REF_PIC_LIST_1][iNumRefIdx]->getPOC() == m_apcRefPicList[m_eListIdFromIdxOfLC[iRefIdxLC]][m_iRefIdxFromIdxOfLC[iRefIdxLC]]->getPOC() )
+#endif 
           {
             m_iRefIdxOfL0FromRefIdxOfL1[iNumRefIdx] = m_iRefIdxFromIdxOfLC[iRefIdxLC];
@@ -396,4 +420,7 @@
 #endif
 
+#if H_MV
+Void TComSlice::setRefPicList( TComList<TComPic*>& rcListPic, std::vector<TComPic*>& refPicSetInterLayer , Bool checkNumPocTotalCurr)
+#else
 #if FIX1071
 Void TComSlice::setRefPicList( TComList<TComPic*>& rcListPic, Bool checkNumPocTotalCurr )
@@ -401,4 +428,5 @@
 Void TComSlice::setRefPicList( TComList<TComPic*>& rcListPic )
 #endif
+#endif
 {
 #if FIX1071
@@ -414,6 +442,8 @@
     }
     
+#if !H_MV
     m_aiNumRefIdx[0] = getNumRefIdx(REF_PIC_LIST_0);
     m_aiNumRefIdx[1] = getNumRefIdx(REF_PIC_LIST_1);
+#endif
   }
 
@@ -425,4 +455,8 @@
   UInt NumPocStCurr1 = 0;
   UInt NumPocLtCurr = 0;
+#if H_MV
+  Int numDirectRefLayers  = getVPS()->getNumDirectRefLayers( getLayerIdInVps() );
+  assert( numDirectRefLayers == refPicSetInterLayer.size() ); 
+#endif
   Int i;
 
@@ -473,5 +507,10 @@
   TComPic*  rpsCurrList0[MAX_NUM_REF+1];
   TComPic*  rpsCurrList1[MAX_NUM_REF+1];
+#if H_MV
+  Int numPocTotalCurr = NumPocStCurr0 + NumPocStCurr1 + NumPocLtCurr + numDirectRefLayers;
+  assert( numPocTotalCurr == getNumRpsCurrTempList() );
+#else
   Int numPocTotalCurr = NumPocStCurr0 + NumPocStCurr1 + NumPocLtCurr;
+#endif
 #if FIX1071
   if (checkNumPocTotalCurr)
@@ -513,4 +552,13 @@
     rpsCurrList0[cIdx] = RefPicSetLtCurr[i];
   }
+#if H_MV
+  for ( i=0; i<numDirectRefLayers;  i++, cIdx++)
+  {
+    if( cIdx <= MAX_NUM_REF )
+    {
+      rpsCurrList0[cIdx] = refPicSetInterLayer[i];
+    }
+  }
+#endif
 
   if (m_eSliceType==B_SLICE)
@@ -529,4 +577,13 @@
       rpsCurrList1[cIdx] = RefPicSetLtCurr[i];
     }
+#if H_MV
+    for ( i=0; i<numDirectRefLayers;  i++, cIdx++)
+    {
+      if( cIdx <= MAX_NUM_REF )
+      {
+        rpsCurrList1[cIdx] = refPicSetInterLayer[i];
+      }
+    }
+#endif
   }
 
@@ -570,4 +627,7 @@
     }
   }
+#if H_MV
+  numRpsCurrTempList = numRpsCurrTempList + getVPS()->getNumDirectRefLayers( getLayerIdInVps() );
+#endif
   return numRpsCurrTempList;
 }
@@ -732,4 +792,7 @@
   m_iPOC                 = pSrc->m_iPOC;
   m_eNalUnitType         = pSrc->m_eNalUnitType;
+#if H_MV
+  m_layerId              = pSrc->m_layerId;
+#endif
   m_eSliceType           = pSrc->m_eSliceType;
   m_iSliceQp             = pSrc->m_iSliceQp;
@@ -784,4 +847,7 @@
       m_apcRefPicList[i][j]  = pSrc->m_apcRefPicList[i][j];
       m_aiRefPOCList[i][j]   = pSrc->m_aiRefPOCList[i][j];
+#if H_MV
+      m_aiRefLayerIdList[i][j] = pSrc->m_aiRefLayerIdList[i][j];
+#endif
     }
   }
@@ -799,4 +865,7 @@
 
   // access channel
+#if H_MV
+  m_pcVPS                = pSrc->m_pcVPS;
+#endif
   m_pcSPS                = pSrc->m_pcSPS;
   m_pcPPS                = pSrc->m_pcPPS;
@@ -1312,5 +1381,9 @@
 , m_bTemporalIdNestingFlag    (false)
 , m_numHrdParameters          (  0)
+#if H_MV
+, m_maxNuhLayerId             (  0)
+#else
 , m_maxNuhReservedZeroLayerId (  0)
+#endif
 , m_hrdParameters             (NULL)
 , m_hrdOpSetIdx               (NULL)
@@ -1327,4 +1400,51 @@
     m_uiMaxLatencyIncrease[i] = 0;
   }
+#if H_MV
+  m_avcBaseLayerFlag = false;
+  m_splittingFlag    = false;
+  
+  for( Int i = 0; i < MAX_NUM_SCALABILITY_TYPES; i++ )
+  {
+    m_scalabilityMask[i] = false;
+    m_dimensionIdLen [i]  = -1; 
+  }
+
+  m_vpsNuhLayerIdPresentFlag = false;
+  m_numOutputLayerSets       = 0;
+
+  for( Int i = 0; i < MAX_VPS_OP_SETS_PLUS1; i++ )
+  {
+    m_vpsProfilePresentFlag   [i] = false;
+    m_profileLayerSetRefMinus1[i] = 0;
+    m_outputLayerSetIdx       [i] = 0;
+    for( Int j = 0; j < MAX_VPS_NUH_LAYER_ID_PLUS1; j++ )
+    {
+      m_outputLayerFlag[i][j] = false;
+    }
+  }
+
+  for( Int i = 0; i < MAX_NUM_LAYER_IDS; i++ )
+  {
+    m_layerIdInVps[i] =  (i == 0 ) ? 0 : -1;         
+  }
+
+  for( Int i = 0; i < MAX_NUM_LAYERS; i++ )
+  {
+    m_layerIdInNuh      [i] = ( i == 0 ) ? 0 : -1; 
+    m_numDirectRefLayers[i] = 0; 
+
+    for( Int j = 0; j < MAX_NUM_LAYERS; j++ )
+    {
+      m_directDependencyFlag[i][j] = false;
+      m_refLayerId[i][j]           = -1; 
+    }
+
+    for( Int j = 0; j < MAX_NUM_SCALABILITY_TYPES; j++ )
+    {
+      m_dimensionId[i][j] = 0;
+    }
+
+  }
+#endif
 }
 
@@ -1336,4 +1456,91 @@
 }
 
+#if H_MV
+
+Bool TComVPS::checkVPSExtensionSyntax()
+{
+  // check splitting flag constraint
+  if ( getSplittingFlag() )
+  {
+    // Derive dimBitOffset[j]
+    Int dimBitOffset[MAX_NUM_SCALABILITY_TYPES+1];
+    Int numScalabilityTypes = getNumScalabilityTypes();
+    dimBitOffset[0] = 0;
+
+    for (Int type = 1; type <= numScalabilityTypes; type++ )
+    {
+      dimBitOffset[ type ] = 0;
+      for (Int dimIdx = 0; dimIdx <= type - 1; dimIdx++)
+        dimBitOffset[ type ] += ( getDimensionIdLen( dimIdx ) );
+    }
+
+    for (Int type = 0; type < getNumScalabilityTypes(); type++ )
+    {
+      for( Int layer = 1; layer < getMaxLayers(); layer++ )
+      {
+        assert( getDimensionId( layer, type ) == ( ( getLayerIdInNuh( layer ) & ( (1 << dimBitOffset[ type + 1 ] ) - 1) ) >> dimBitOffset[ type ] ) );
+      }; 
+  };
+  }
+
+  for( Int layer = 1; layer < getMaxLayers(); layer++ )
+  {
+    // check layer_id_in_nuh constraint
+    assert( getLayerIdInNuh( layer ) > getLayerIdInNuh( layer -1 ) );
+  }
+  return true; 
+}
+
+Int TComVPS::getNumScalabilityTypes()
+{
+  return scalTypeToScalIdx( ScalabilityType(MAX_NUM_SCALABILITY_TYPES) );
+}
+
+Int TComVPS::scalTypeToScalIdx( ScalabilityType scalType )
+{
+  assert( scalType >= 0 && scalType <= MAX_NUM_SCALABILITY_TYPES ); 
+  assert( scalType == MAX_NUM_SCALABILITY_TYPES || getScalabilityMask( scalType ) );
+
+  Int scalIdx = 0; 
+  for( Int curScalType = 0; curScalType < scalType; curScalType++ )
+  {
+    scalIdx += ( getScalabilityMask( curScalType ) ? 1 : 0 );
+  }
+
+  return scalIdx; 
+}
+
+
+
+Void TComVPS::setScalabilityMask( UInt val )
+{
+  for ( Int scalType = 0; scalType < MAX_NUM_SCALABILITY_TYPES; scalType++ ) 
+    setScalabilityMask( scalType, ( val & (1 << scalType ) ) == 1 );
+}
+
+Void TComVPS::calcIvRefLayers()
+{
+  for( Int i = 1; i <= getMaxLayers(); i++ )
+  { 
+    m_numDirectRefLayers[ i ] = 0; 
+    for( Int j = 0 ; j < i; j++ )
+      if( m_directDependencyFlag[ i ][ j ])
+        m_refLayerId[ i ][ m_numDirectRefLayers[ i ]++ ] = m_layerIdInNuh[ j ];    
+  }
+}
+
+Int TComVPS::getRefLayerId( Int layerIdInVps, Int idx )
+{
+  assert( idx >= 0 && idx < m_numDirectRefLayers[layerIdInVps] );     
+  Int layerIdInNuh = m_refLayerId[ layerIdInVps ][ idx ];    
+  assert ( layerIdInNuh >= 0 ); 
+  return layerIdInNuh;
+}
+
+Int TComVPS::getScalabilityId( Int layerIdInVps, ScalabilityType scalType )
+{
+  return ( ( layerIdInVps != 0 )&& getScalabilityMask( scalType ) ) ? getDimensionId( layerIdInVps, scalTypeToScalIdx( scalType ) ) : 0;
+}
+#endif
 // ------------------------------------------------------------------------------------------------
 // Sequence parameter set (SPS)
@@ -1382,4 +1589,7 @@
 , m_vuiParametersPresentFlag  (false)
 , m_vuiParameters             ()
+#if H_MV
+, m_interViewMvVertConstraintFlag (false)
+#endif
 {
   for ( Int i = 0; i < MAX_TLAYER; i++ )
@@ -1845,4 +2055,91 @@
 }
 
+#if H_MV
+Void TComSlice::createAndApplyIvReferencePictureSet( TComPicLists* ivPicLists, std::vector<TComPic*>& refPicSetInterLayer )
+{
+  refPicSetInterLayer.clear(); 
+
+  for( Int i = 0; i < getVPS()->getNumDirectRefLayers( getLayerIdInVps() ); i++ ) 
+  {
+    Int layerIdRef = getVPS()->getRefLayerId( getLayerIdInVps(), i ); 
+    TComPic* picRef = ivPicLists->getPic( layerIdRef, getPOC() ) ; 
+    assert ( picRef != 0 ); 
+
+    picRef->getPicYuvRec()->extendPicBorder(); 
+    picRef->setIsLongTerm( true );        
+    picRef->getSlice(0)->setReferenced( true );       
+
+    refPicSetInterLayer.push_back( picRef ); 
+  }
+}
+
+Void TComSlice::markIvRefPicsAsShortTerm( std::vector<TComPic*> refPicSetInterLayer )
+{
+  // Mark as shortterm 
+  for ( Int i = 0; i < refPicSetInterLayer.size(); i++ ) 
+  {
+    refPicSetInterLayer[i]->setIsLongTerm( false ); 
+  }
+}
+
+Void TComSlice::markIvRefPicsAsUnused( TComPicLists* ivPicLists, std::vector<Int> targetDecLayerIdSet, TComVPS* vps, Int curLayerId, Int curPoc )
+{
+  // Fill targetDecLayerIdSet with all layers if empty. 
+  if (targetDecLayerIdSet.size() == 0 )    
+  {
+    for ( Int layerIdInVps = 0; layerIdInVps < vps->getMaxLayers(); layerIdInVps++ )
+    {
+      targetDecLayerIdSet.push_back( vps->getLayerIdInNuh( layerIdInVps ) ); 
+    }
+  }     
+
+  Int numTargetDecLayers = (Int) targetDecLayerIdSet.size(); 
+  Int latestDecIdx; 
+  for ( latestDecIdx = 0; latestDecIdx < numTargetDecLayers; latestDecIdx++)
+  {
+    if ( targetDecLayerIdSet[ latestDecIdx ] == curLayerId )
+      break; 
+  }        
+
+  for( Int i = 0; i <= latestDecIdx; i++ ) 
+  {
+    if ( vps->nuhLayerIdIncluded( targetDecLayerIdSet[ i ] ) )
+    {
+      TComPic* pcPic = ivPicLists->getPic( targetDecLayerIdSet[ i ], curPoc ); 
+      if( pcPic->getSlice(0)->isReferenced() && pcPic->getSlice(0)->getTemporalLayerNonReferenceFlag() ) 
+      { 
+        Bool remainingInterLayerReferencesFlag = false; 
+        for( Int j = latestDecIdx + 1; j < numTargetDecLayers; j++ )
+        { 
+          TComVPS* vpsSlice = pcPic->getSlice(0)->getVPS(); 
+          if ( vps->nuhLayerIdIncluded( targetDecLayerIdSet[ j ] ) )
+          {
+            Int targetDecLayerIdinVPS = vpsSlice->getLayerIdInVps( targetDecLayerIdSet[ j ] ); 
+            for( Int k = 0; k < vpsSlice->getNumDirectRefLayers( targetDecLayerIdinVPS ); k++ )
+              if ( targetDecLayerIdSet[ i ] == vpsSlice->getRefLayerId( targetDecLayerIdinVPS,  k  ) )
+                remainingInterLayerReferencesFlag = true;
+          }
+        }
+        if( !remainingInterLayerReferencesFlag )
+          pcPic->getSlice(0)->setReferenced( false );                   
+      }
+    }
+  }
+}
+
+Void TComSlice::xPrintRefPicList()
+{  
+  for ( Int li = 0; li < 2; li++)
+  {    
+    std::cout << std::endl << "RefPicListL" <<  li << ":" << std::endl; 
+    for (Int rIdx = 0; rIdx <= (m_aiNumRefIdx[li]-1); rIdx ++)
+    {      
+      if (rIdx == 0 && li == 0) m_apcRefPicList[li][rIdx]->print( true );
+        
+      m_apcRefPicList[li][rIdx]->print( false );
+    }
+  }
+}
+#endif
 /** get scaling matrix from RefMatrixID
  * \param sizeId size index
@@ -2067,4 +2364,7 @@
   {
     Int spsId = pps->getSPSId();
+#if H_MV
+    // active parameter sets per layer should be used here
+#else
     if (!isIRAP && (spsId != m_activeSPSId))
     {
@@ -2072,4 +2372,5 @@
       return false;
     }
+#endif
     TComSPS *sps = m_spsMap.getPS(spsId);
     if (sps)
@@ -2126,4 +2427,15 @@
 }
 
+#if H_MV
+Void TComPTL::copyLevelFrom( TComPTL* source )
+{
+  getGeneralPTL()->setLevelIdc( source->getGeneralPTL()->getLevelIdc() );
+  for( Int subLayer = 0; subLayer < 6; subLayer++ )
+  {
+    setSubLayerLevelPresentFlag( subLayer, source->getSubLayerLevelPresentFlag( subLayer ) );
+    getSubLayerPTL( subLayer )->setLevelIdc( source->getSubLayerPTL( subLayer )->getLevelIdc() );
+  }
+}
+#endif
 #if SIGNAL_BITRATE_PICRATE_IN_VPS
 TComBitRatePicRateInfo::TComBitRatePicRateInfo()
